#ifndef SBS_H
#define SBS_H

#include <limits.h>

#define ROOTDIR "/SBS"


void sbs_init();
void sbs_add(int, char **);
void sbs_commit(int, char **);
void sbs_update(int, char **);

char *unique_name(char *path);
char *split_path(char *path, char **file);
void createdirs(char *path);
char *get_abs_path(char *name);
int set_most_recent(char *path);
int get_version_num(char *name);

void get_repository_path(char *rp, char *path, int size);
void copy_file(char *path, char *rp);
void copy_dir(char *path, char *rp);
void update_dir(char *path, char *rp);
struct ll {
    char str[PATH_MAX];
    struct ll *next;
};
typedef struct ll List;

List *add_most_recent(char *name, List *head);
List *dequeue(List **head);
#endif
